<?php

namespace Pinpoint\OrderIdentification\Observer\Adminhtml\Order;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer;

/**
 * Class UserLog
 * @package Pinpoint\OrderIdentification\Observer\Adminhtml\Order
 */
class UserLog implements ObserverInterface
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $state;

    /**
     * @var \Magento\Backend\Model\Auth\Session
     */
    protected $authSession;

    /**
     * UserLog constructor.
     * @param \Magento\Framework\App\State $state
     * @param \Magento\Backend\Model\Auth\Session $authSession
     */
    public function __construct(
        \Magento\Framework\App\State $state,
        \Magento\Backend\Model\Auth\Session $authSession
    ) {
        $this->state = $state;
        $this->authSession = $authSession;
    }

    /**
     * @param Observer $observer
     * @return $this
     */
    public function execute(Observer $observer)
    {
        if ($this->state->getAreaCode() == \Magento\Framework\App\Area::AREA_ADMINHTML) {
            $user = $this->authSession->getUser();
            $order = $observer->getData('order');

            if ($user && $order) {
                $order->setData('admin_order_user', $user->getData('username'));
                $order->setData('admin_order_user_id', $user->getId());
            }
        }

        return $this;
    }
}
